<?php
// +-----------------------------------------------------------------------+
// | Plugin Name : Event Cats                                              |
// | Plugin Version : 1.0                                                  |
// | File Version : 1.0                                                    |
// | Plugin Version author : LucMorizur                                    |
// | Plugin description : (plugin for Piwigo, http://piwigo.org )          |
// | This plugin allows an account to be automatically logged in ; and to  |
// | let users duplicate the account they are logged with, to get benefits |
// | of the groups of the previous account, immediately on their new acc.  |
// | Ce plugin permet d'identifier automatiquement un compte ; et permet à |
// | un utilisateur de dupliquer un compte, pour que le nouveau compte     |
// | bénéficie immédiatement de l'affectation aux groupes de l'ancien cpte |
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf, $lang, $test1, $prefixeTable, $ec_err, $page,
 $ec_lists,   // array of following arrays :
              //   $ec_lists['ec_table'] :
              //     Event Cats table, in function of each entry id
              //   $ec_lists['ec_codes'] : // Used ?
              //     array of useful data, in function of entries codes
              //   $ec_lists['add_pages'] :
              //     array of Add. Pages names in function of their id
              //   $ec_lists['categories'] :
              //     array of category names in function of their id
              //   $ec_lists['user_ids'] :
              //     array of usernames in function of their id
 $ec_ap_ok;   // whether Additional Pages is installed and activated

load_language('plugin.lang', EVNTCATS_PATH);

include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
include_once(PHPWG_ROOT_PATH.'include/functions_url.inc.php');
include_once(EVNTCATS_PATH.'include/evntcats_funcs.inc.php');
$my_base_url = get_admin_plugin_menu_link(__FILE__);

$template->assign( 'EVNTCATS_VERSION' , EVNTCATS_INFO_VERSION);
$me = get_plugin_data($plugin_id);
$template->clear_assign('ec_infos');
$template->append('head_elements',
  '<link rel="stylesheet" type="text/css" href="'.
  EVNTCATS_PATH.'admin/evntcats_theme.css">'
);

// +-----------------------------------------------------------------------+
// |                            Tabsheet
// +-----------------------------------------------------------------------+
if (!isset($_GET['tab']))
    $page['tab'] = 'autolog';
else
    $page['tab'] = $_GET['tab'];

$tabsheet = new tabsheet();
$tabsheet->add('autolog',
               l10n('ec_tab_autoid'),
               $my_base_url.'&amp;tab=autolog');
$tabsheet->add('config',
               l10n('ec_tab_config'),
               $my_base_url.'&amp;tab=config');
$tabsheet->select($page['tab']);
$tabsheet->assign();

$template->assign(
 array('U_HELP' => get_root_url().'popuphelp.php?page=event_cats'));

$template->assign('EVNTCATS_URLS', array (
 'ROOT'     => EVNTCATS_PATH,
 'DISABLE'  => PHPWG_ROOT_PATH.
  'admin.php?page=plugin&section=event_cats%2Fadmin%2Fevntcats_admin.php&disable=',
 'DELETE'   => PHPWG_ROOT_PATH.
  'admin.php?page=plugin&section=event_cats%2Fadmin%2Fevntcats_admin.php&delete='
));

/****************************************************************************/

$code_list = array();
build_ec_lists(); // in evntcats_funcs.php

if (isset($_GET['delete'])) {
  if (array_key_exists($_GET['delete'],$ec_lists['ec_table'])) {
    $t = $ec_lists['ec_table'][$_GET['delete']]['code'];
    $q = pwg_query('
     DELETE FROM '.EVNTCATS_TABLE.' 
     WHERE id = '.$_GET['delete']
    );
    if ($q = 1) {
      $page['infos']['infos'] = l10n('ec_entry_del_ok_pre').$t.
       l10n('ec_entry_del_ok_end');
    }
    else {
      $page['errors'][] = l10n('ec_entry_del_nok_pre').$t.
       l10n('ec_entry_del_nok_end');
    }
    build_ec_table();
  }
}

if (isset($_GET['disable'])) {
  if (array_key_exists($_GET['disable'],$ec_lists['ec_table'])) {
    $t = $ec_lists['ec_table'][$_GET['disable']]['code'];
    $q = pwg_query('
     UPDATE '.EVNTCATS_TABLE.' 
     SET action = \'ec_outdated\' 
     WHERE id = '.$_GET['disable']
    );
    if ($q = 1) {
      $page['infos']['infos'] = l10n('ec_entry_dis_ok_pre1').$t.
       l10n('ec_entry_dis_ok_end1');
      if (isset($_GET['add_p'])) {
        if (array_key_exists($_GET['add_p'],$ec_lists['add_pages'])) {
          $q = pwg_query('
           UPDATE '.EVNTCATS_TABLE.' 
           SET arg1 = '.$_GET['add_p'].' 
           WHERE id = '.$_GET['disable']
          );
          if ($q = 1) {
            $page['infos']['infos'].=
             l10n('ec_entry_dis_ok_pre2').
             $_GET['add_p'].
             l10n('ec_entry_dis_ok_mid2').
             $ec_lists['add_pages'][$_GET['add_p']].
             l10n('ec_entry_dis_ok_end2');
          }
          else {
            $page['errors'][] =
             l10n('ec_entry_dis_nok_pre2').
             $t.
             l10n('ec_entry_dis_nok_mid2').
             $_GET['add_p'].
             l10n('ec_entry_dis_nok_end2');
          }
        }
      }
      else {
        $q = pwg_query('
         UPDATE '.EVNTCATS_TABLE.' 
         SET arg1 = NULL 
         WHERE id = '.$_GET['disable']
        );
        if ($q != 1) {
          $page['errors'][] =
           l10n('ec_entry_dis_nok_pre3').
           $t.
           l10n('ec_entry_dis_nok_end3');
        }
      }
    }
    else {
      $page['errors'][] = l10n('ec_entry_dis_nok_pre1').$t.
       l10n('ec_entry_dis_nok_end1');
    }
    build_ec_table();
  }
}

if (isset($_GET[''])) {
}

if (isset($_GET[''])) {
}

if (isset($_GET[''])) {
}

if (isset($_GET[''])) {
}

/****************************************************************
* Construction of array var to be transmitted to tpl file,      *
* containing all infos to be displayed in the code array table. *
****************************************************************/

$span_err_pre = '<span style = "color: red; font-weight: bold;">';
$span_err_end = '</span>';

foreach ($ec_lists['ec_table'] as $ec_entry) {
    
  $a = NULL;
  $dspl     = '';
  $url_end  = '';
  $i        = intval($ec_entry['id']);
  $arg1     = $ec_entry['arg1'];
  $arg1_int = intval($arg1);
  $arg2     = $ec_entry['arg2'];
  $arg2_int = intval($arg2);
  $log_OK   = (strpos($ec_entry['action'], 'ec_ok') !== false);
  
  // No specific need for "code" displaying
  
  // "username" displaying
  $username = ($log_OK) ?
   $ec_lists['user_ids'][intval($ec_entry['user_id'])] : '';
  
  // No specific need for "action" displaying
  
  // "displayed page" : # of the AP, or of the category...
  switch ($ec_entry['action']) {
    
    case 'ec_ok_forced_pb' :
      $page['errors'][$ec_entry['code']] = l10n('ec_forced_pb');
    case 'ec_ok' :
    case 'ec_ok_img_pb' :
      $a = 0;
      if (!empty($ec_entry['arg1'])) $a++;
      if (!empty($ec_entry['arg2'])) $a+= 2;
      switch ($a) {
        case 0: // Home
          $dspl = l10n('ec_dspl_ok_home');
        break;
        case 1: // Category
        case 3: // Image
          $url_end = '&cat='.$arg1;
          $dspl =
           l10n('ec_dspl_ok_cat_pre').
           $arg1.
           l10n('ec_dspl_ok_cat_mid').
           $ec_lists['categories'][$arg1_int].
           l10n('ec_dspl_ok_cat_end')
          ;
          if ($ec_entry['action'] == 'ec_ok_img_pb') {
            $url_end.= '&img='.$arg2;
            $page['errors'][] = l10n('ec_image_miss');
            $dspl.=
             '<br>'.$span_err_pre.
             l10n('ec_dspl_nok_img2_pre').
             $arg2.
             l10n('ec_dspl_nok_img2_mid').
             $arg1.
             l10n('ec_dspl_nok_img2_end').
             $span_err_end
            ;
          }
          elseif ($a == 3) { // Image
            $url_end.= '&img='.$arg2;
            $t = mysql_fetch_row(pwg_query('
             SELECT `name`, `file`
             FROM `'.IMAGES_TABLE.'`
             WHERE `id` = "'.$arg2.'"
            '));
            $dspl.=
             '<br>'.
             l10n('ec_dspl_ok_img2_pre').
             $arg2.
             l10n('ec_dspl_ok_img2_mid1').
             $t[0].
             l10n('ec_dspl_ok_img2_mid2').
             $t[1].
             l10n('ec_dspl_ok_img2_end')
            ;
          }
        break;
        case 2: // Additional Page
          $url_end = '&ap='.$arg2;
          $dspl = ($ec_ap_ok) ?
           l10n('ec_dspl_ok_ap_pre').
           $arg2.
           l10n('ec_dspl_ok_ap_mid').
           $ec_lists['add_pages'][$arg2_int].
           l10n('ec_dspl_ok_ap_end')
          :
           l10n('ec_dspl_ok_home')
          ;
        break;
      }
    break;
    
    case 'ec_nok' :
      if (empty($ec_entry['arg2'])) {
        $dspl = l10n('ec_dspl_nok_acc_denied');
      }
      else {
        $dspl = ($ec_ap_ok) ?
         l10n('ec_dspl_ok_ap_pre').
         $arg2.
         l10n('ec_dspl_ok_ap_mid').
         $ec_lists['add_pages'][$arg2_int].
         l10n('ec_dspl_ok_ap_end')
        :
         l10n('ec_dspl_nok_acc_denied')
        ;
      }
    break;
    
    case 'ec_nok_ap_pb' : // No need to check here if Additional Pages is
    case 'ec_ok_ap_pb' :  // active : we can arrive here only when it is.
      $page['errors'][] = l10n('ec_add_page_miss');
      if ($ec_entry['action'] == 'ec_ok_ap_pb') {
        $url_end = '&ap='.$arg2;
        $dspl = l10n('ec_dspl_ok_home');
      }
      else {
        $dspl = l10n('ec_dspl_nok_acc_denied');
      }
      $dspl.=
       $span_err_pre.
       l10n('ec_dspl_nok_ap_pre').
       $arg2.
       l10n('ec_dspl_nok_ap_end').
       $span_err_end
      ;
    break;
    
    case 'ec_ok_cat_pb' :
      $url_end = '&cat='.$arg1;
      $page['errors'][] = l10n('ec_category_miss');
      $dspl =
       l10n('ec_dspl_nok_home').
       $span_err_pre.
       l10n('ec_dspl_nok_img1_pre').
       $arg1.
       l10n('ec_dspl_nok_img1_end').
       $span_err_end
      ;
    break;
    
    case 'ec_nok_action_pb' :
      $page['errors'][$ec_entry['code']] = l10n('ec_action_pb');
      $username =
       $span_err_pre.
       l10n('ec_dspl_nok_actn').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
    
    case 'ec_nok_userid_pb' :
      $page['errors'][$ec_entry['code']] = l10n('ec_username_pb');
      $username =
       $span_err_pre.
       l10n('ec_dspl_usr_pb').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
    
    case 'ec_nok_userid_miss' :
      $page['errors'][$ec_entry['code']] = l10n('ec_username_miss');
      $username =
       $span_err_pre.
       l10n('ec_dspl_nok_usr_pre').
       $ec_entry['user_id'].
       l10n('ec_dspl_nok_usr_end').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
  }
  
  // construction of $code_URL
  $code_URL =
   ROOT_URL.
   'index.php?autolog='.
   $ec_entry['code'].
   $url_end
  ;
  
  $code_list[$i] = array(
   'id'       => $i,
   'Code'     => $ec_entry['code'],
   'Username' => $username,
   'Action'   => $ec_entry['action'],
   'Arg1'     => $dspl,
   'Forced'   => $ec_entry['forced'],
   'code_URL' => $code_URL,
   'log_OK'   => $log_OK,
  );
}

/*
print '<pre>';
//print_r('ROOT_URL : '.ROOT_URL.'<br>EVNTCATS_PATH : '.EVNTCATS_PATH);
print('ROOT_URL : '.ROOT_URL.'<br>EVNTCATS_PATH : '.EVNTCATS_PATH);
print '</pre>';
*/

$template->assign('ec_howto', (count($page['errors']) == 0 and count($page['infos']) == 0));

$template->assign('ec_ap_ok',$ec_ap_ok);
$template->assign('code_list',$code_list);
$template->assign('ec_lists',$ec_lists);
$template->assign('EVNTCATS_PATH',EVNTCATS_PATH);
$template->assign('RACINE_URL',ROOT_URL);

// $template->assign('test0tpl',str_from_var($ec_lists['ec_codes']));
$template->assign('test1tpl',str_from_var($ec_lists));
$template->assign('test2tpl',str_from_var($page['errors']));
$template->assign('test3tpl',str_from_var($code_list));

/* C'est quoi, ça ?...
if ( isset($_POST['submit']) )
  {
    if (isset($_POST['account']) and isset($_POST['code']))
      {
        $conf['auto_log'][$_POST['code']] = $_POST['account'];
      }
    else
      {
        $page['errors']='arg_missing';
      }

    if (isset($_POST['duplication']))
      {
        $conf['allow_user_registration'] = ($_POST['duplication'] == '1');
      }
  }
*/

$template->set_filenames(array('evntcats_admin_content' => dirname(__FILE__).'/evntcats_admin.tpl'));
$template->assign_var_from_handle('ADMIN_CONTENT','evntcats_admin_content');
?>